/*
    B3.c
    Generated by Gene-Auto toolset ver 2.4.9
    (launcher GALauncherSCICOS)
    Generated on: 15/06/2012 14:22:16.226
    source model: Subsystem
    model version: 6.3
    last saved by:
    last saved on:
*/

/* Includes */

#include "B3.h"

/* Variable definitions */

/*  Output from <SystemBlock: name=Subsystem>/<SystemBlock: name=B3>/<SystemBlock: name=B3_6>/<OutDataPort: name=B3_6_3>  */
REAL B3_B3_6_B3_6_3 = 0.0;
/*  Output from <SystemBlock: name=Subsystem>/<SystemBlock: name=B3>/<SystemBlock: name=B3_7>/<OutDataPort: name=B3_7_4>  */
REAL B3_B3_7_B3_7_4 = 0.0;
t_B3_7_io _B3_7_io;
t_B3_6_io _B3_6_io;
UINT8 i1_1;

/* Function definitions */

void B3_init(t_Subsystem_state *_state_) {
    /*  START Block: -35079f4:137f00fab4d:-7ce2  */
    _state_->B3_11_memory = 0.0;
    /*  END Block: -35079f4:137f00fab4d:-7ce2  */
}

void B3_compute(t_B3_io *_io_, t_Subsystem_state *_state_) {
    /*  Output from <SystemBlock: name=Subsystem>/<SystemBlock: name=B3>/<SourceBlock: name=B3_1>/<OutDataPort: name=null>  */
    REAL B3_1_null;
    /*  Output from -35079f4:137f00fab4d:-7d01/<OutDataPort: name=null>  */
    REAL B3_2_null;
    /*  Output from -35079f4:137f00fab4d:-7cff/<OutDataPort: name=null>  */
    REAL B3_3_null;
    /*  Output from -35079f4:137f00fab4d:-7cfd/<OutDataPort: name=null>  */
    REAL B3_4_null;
    /*  Output from -35079f4:137f00fab4d:-7cef/<OutDataPort: name=null>  */
    REAL B3_8_null;
    /*  Output from -35079f4:137f00fab4d:-7ceb/<OutDataPort: name=null>  */
    REAL B3_9_null;
    /*  Output from -35079f4:137f00fab4d:-7ce7/<OutDataPort: name=null>  */
    REAL B3_10_null;
    /*  Output from -35079f4:137f00fab4d:-7ce2/<OutDataPort: name=null>  */
    REAL B3_11_null;
    /*  Output from -35079f4:137f00fab4d:-7cca/<OutDataPort: name=null>  */
    REAL B3_18_null[2];
    /*  START Block: -35079f4:137f00fab4d:-7ce2  */
    B3_11_null = _state_->B3_11_memory;
    /*  END Block: -35079f4:137f00fab4d:-7ce2  */
    /*  START Block: -35079f4:137f00fab4d:-7d01  */
    B3_2_null = 2.0;
    /*  END Block: -35079f4:137f00fab4d:-7d01  */
    /*  START Block: -35079f4:137f00fab4d:-7cff  */
    B3_3_null = 5.0;
    /*  END Block: -35079f4:137f00fab4d:-7cff  */
    /*  START Block: -35079f4:137f00fab4d:-7cfd  */
    B3_4_null = 2.0;
    /*  END Block: -35079f4:137f00fab4d:-7cfd  */
    /*  START Block: -35079f4:137f00fab4d:-7ce7  */
    if (B3_11_null >= 2.0) {
        B3_10_null = B3_3_null;
    } else {
        B3_10_null = B3_4_null;
    }
    /*  END Block: -35079f4:137f00fab4d:-7ce7  */
    /*  START Block: null  */
    B3_1_null = _io_->B3_1;
    /*  END Block: null  */
    /*  START Block: -35079f4:137f00fab4d:-7ceb  */
    B3_9_null = -B3_2_null + B3_1_null;
    /*  END Block: -35079f4:137f00fab4d:-7ceb  */
    /*  START Block: -35079f4:137f00fab4d:-7cfb  */
    if (B3_9_null > 0.0) {
        /*  Call block null  */
        _B3_6_io.B3_6_1 = B3_1_null;
        B3_6_compute(&_B3_6_io, _state_);
        B3_B3_6_B3_6_3 = _B3_6_io.B3_6_3;
    } else {
        /*  Call block null  */
        _B3_7_io.B3_7_1 = B3_B3_6_B3_6_3;
        B3_7_compute(&_B3_7_io, _state_);
        B3_B3_7_B3_7_4 = _B3_7_io.B3_7_4;
    }
    /*  END Block: -35079f4:137f00fab4d:-7cfb  */
    /*  START Block: -35079f4:137f00fab4d:-7cef  */
    B3_8_null = B3_B3_6_B3_6_3 * B3_10_null;
    /*  END Block: -35079f4:137f00fab4d:-7cef  */
    /*  START Block: -35079f4:137f00fab4d:-7cca  */
    B3_18_null[0] = B3_B3_7_B3_7_4;
    B3_18_null[1] = B3_8_null;
    /*  END Block: -35079f4:137f00fab4d:-7cca  */
    /*  START Block: null  */
    for (i1_1 = 0; i1_1 < 2; i1_1++) {
        _io_->B3_12[i1_1] = B3_18_null[i1_1];
    }
    /*  END Block: null  */
    /*  START Block memory write: -35079f4:137f00fab4d:-7ce2  */
    _state_->B3_11_memory = B3_1_null;
    /*  END Block memory write: -35079f4:137f00fab4d:-7ce2  */
}

